******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #1 ANNUALBILL.DO

clear
capture log close
log using "annualbill.slf", replace text
set more off
set mem 1222m

****** -------------------------  QUARTER 1 -----------------------------

u f:\dataslave\sce_2006q1_base_corrected_1222.dta

drop if days==0

g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"


**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW 

g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0

compress

**  PRORATE BILLS AT BEGINNING OR END OF YEAR

drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802


 drop base_pre

replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio

drop dyratio start_date end_date

save xxx, replace

keep use* flaguse CARE days
g tier=1
replace tier=2 if use2>0
replace tier=3 if use3>0
replace tier=4 if use4>0
replace tier=5 if use5>0
drop if flaguse==0
sort CARE tier
collapse (sum) days, by(CARE tier)
save tieruse, replace
clear

u xxx

sort id aid CARE region zip zip4 flaguse 

collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)

compress

save SCEannual, replace

clear


****** -------------------------  QUARTER 2 -----------------------------

u f:\dataslave\sce_2006q2_base_corrected_1222.dta
drop if days==0

g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"


**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW OR HIGH CONSUMPTION

g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0

compress

**  PRORATE BILLS AT BEGINNING OR END OF YEAR

drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802

 drop base_pre

replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio

drop dyratio start_date end_date

save xxx, replace

keep  use* flaguse CARE days
g tier=1
replace tier=2 if use2>0
replace tier=3 if use3>0
replace tier=4 if use4>0
replace tier=5 if use5>0
drop if flaguse==0
sort CARE tier
collapse (sum) days, by(CARE tier)
save yyy, replace
clear
u tieruse
append using yyy
save tieruse, replace
clear

u xxx

sort id aid CARE region zip zip4 flaguse 

collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)

compress
save xxx, replace
clear
u SCEannual
append using xxx
sort id aid CARE region zip zip4 flaguse
collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)
save SCEannual, replace
clear


****** -------------------------  QUARTER 3 -----------------------------

u f:\dataslave\sce_2006q3_base_corrected_1222.dta
drop if days==0

g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"


**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW OR HIGH CONSUMPTION

g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0

compress

**  PRORATE BILLS AT BEGINNING OR END OF YEAR

drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802

 drop base_pre

replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio

drop dyratio start_date end_date

save xxx, replace

keep  use* flaguse CARE days
g tier=1
replace tier=2 if use2>0
replace tier=3 if use3>0
replace tier=4 if use4>0
replace tier=5 if use5>0
drop if flaguse==0
sort CARE tier
collapse (sum) days, by(CARE tier)
save yyy, replace
clear
u tieruse
append using yyy
save tieruse, replace
clear

u xxx

sort id aid CARE region zip zip4 flaguse 

collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)

compress
save xxx, replace
clear
u SCEannual
append using xxx
sort id aid CARE region zip zip4 flaguse 
collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)
save SCEannual, replace
clear


****** -------------------------  QUARTER 4 -----------------------------

u f:\dataslave\sce_2006q4_base_corrected_1222.dta
drop if days==0

g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"


**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW OR HIGH CONSUMPTION

g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0

compress

**  PRORATE BILLS AT BEGINNING OR END OF YEAR

drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802

 drop base_pre

replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio

drop dyratio start_date end_date

save xxx, replace

keep  use* flaguse CARE days
g tier=1
replace tier=2 if use2>0
replace tier=3 if use3>0
replace tier=4 if use4>0
replace tier=5 if use5>0
drop if flaguse==0
sort CARE tier
collapse (sum) days, by(CARE tier)
save yyy, replace
clear
u tieruse
append using yyy
save tieruse, replace
clear

u xxx

sort id aid CARE region zip zip4 flaguse 

collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)

compress
save xxx, replace
clear
u SCEannual
append using xxx
sort id aid CARE region zip zip4 flaguse 
collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)
save SCEannual, replace
clear



****** -------------------------  QUARTER 5 early 2007 -----------------------------


u f:\dataslave\sce_2007q1_base_corrected_1222.dta
drop if days==0

g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"


**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW OR HIGH CONSUMPTION

g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0

compress

**  PRORATE BILLS AT BEGINNING OR END OF YEAR

drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802

 drop base_pre

replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio

drop dyratio start_date end_date

save xxx, replace

keep  use* flaguse CARE days
g tier=1
replace tier=2 if use2>0
replace tier=3 if use3>0
replace tier=4 if use4>0
replace tier=5 if use5>0
drop if flaguse==0
sort CARE tier
collapse (sum) days, by(CARE tier)
save yyy, replace
clear
u tieruse
append using yyy
save tieruse, replace
clear

u xxx

sort id aid CARE region zip zip4 flaguse 

collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)

compress
save xxx, replace
clear
u SCEannual
append using xxx
sort id aid CARE region zip zip4 flaguse 
collapse (sum) days base use*, by (id aid CARE region zip zip4 flaguse)
save SCEannual, replace

summ

clear

u tieruse

sort CARE tier
collapse (sum) days, by(CARE tier)
egen totdays=sum(days), by(CARE)
g daysh=days/totdays
list CARE tier days totdays daysh

exit
