******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #5, ALTRATES.DO

clear
capture log close
set more off
set mem 1200m
log using "altrates.slf", replace text

u SCEannual

summ flaguse
drop if flaguse~=1

drop flaguse 
capture drop rnd

g used=use/days

sort bg
merge bg using c:\billtiers\income_bg_2008_0301.dta
tab _merge
drop if _merge~=3
drop _merge
drop if p_under_20==.
summ

sort CARE

collapse (sum) use1 use2 use3 use4 use5, by(CARE)

g rate51=0.1162 if CARE==0
g rate52=0.1361 if CARE==0
g rate53=0.2201 if CARE==0
g rate54=0.3049 if CARE==0
g rate55=0.3049 if CARE==0

replace rate51=0.0834 if CARE==1
replace rate52=0.1053 if CARE==1
replace rate53=0.1691 if CARE==1
replace rate54=0.1717 if CARE==1
replace rate55=0.1717 if CARE==1

g totrev=(rate51*use1+rate52*use2+rate53*use3+rate54*use4+rate55*use5)

g rate11=(totrev) / (use1+use2+use3+use4+use5)

g rate21=(totrev) / (use1+1.18*(use2+use3+use4+use5))
g rate22=1.18*rate21

list CARE rate11 rate21 rate22

sort CARE
save altrates, replace

collapse (sum) totrev use* (max) rate*

g CARE=0

g drev=(rate51*use1+rate52*use2+rate53*use3+rate54*use4+rate55*use5)-totrev
g drate=drev/(use1+use2+use3+use4+use5)

g rate51A=rate51-drate
g rate52A=rate52-drate
g rate53A=rate53-drate
g rate54A=rate54-drate
g rate55A=rate55-drate

g rate11A=(totrev) / (use1+use2+use3+use4+use5)

g rate21A=(totrev) / (use1+1.18*(use2+use3+use4+use5))
g rate22A=1.18*rate21A

list

sort CARE
save altratesA, replace

exit
