******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #8 BILLCALC5A.DO

clear
capture log close
set more off
set mem 1200m
log using "billcalc5A.slf", replace text

u SCEannual
drop rnd

*replace CARE=0

summ days flaguse
drop if flaguse~=1
drop flaguse
summ days

g used=use/days

**SET BASIC PROPENSITIES TO SIGN UP FOR CARE NOW BASED ON 78% PENETRATION
scalar CAREshr1=0.7359
scalar CAREshr2=0.4506
scalar CAREshr3=0.1008
scalar CAREshr4=0.0063
scalar CAREshr5=0.0001

sort bg
merge bg using c:\dropbox\billtiers\bt201102\censusdata.dta
tab _merge
drop if _merge~=3
drop _merge
drop if p_under_20==.
save c:\temp\temp1, replace

u c:\billtiers\bt200908\sce\altratesa
keep rate*
g mrgvar=1
sort mrgvar
save c:\temp\temp2, replace


u c:\temp\temp1

***set income bracket based on median HH income
g incM=1
replace incM=2 if medhhinc>20000 & medhhinc<=40000
replace incM=3 if medhhinc>40000 & medhhinc<=60000
replace incM=4 if medhhinc>60000 & medhhinc<=100000
replace incM=5 if medhhinc>100000

sort incM
collapse (sum) days use*, by(incM)
drop used
g used=use/days
g mrgvar=1
sort mrgvar
merge mrgvar using c:\temp\temp2

g bill5=rate51A*use1+rate52A*use2+rate53A*use3+rate54A*use4+rate55A*use5
g bill2=rate21A*use1+rate22A*(use2+use3+use4+use5)
g bill1=rate11A*(use1+use2+use3+use4+use5)

g annbill5=365*(bill5/days)
g annbill2=365*(bill2/days)
g annbill1=365*(bill1/days)

egen totrev5=sum(bill5)
egen totrev2=sum(bill2)
egen totrev1=sum(bill1)

summ totrev* if mrgvar==1

g revshr5=bill5/totrev5
g revshr2=bill2/totrev2
g revshr1=bill1/totrev1

g avgP5=bill5/use
g avgP2=bill2/use
g avgP1=bill1/use

sort incM

list incM annbill*

list incM revshr*

list incM avgP*

egen totdays=sum(days)
g daysshr=days/totdays
list incM used daysshr

clear

u c:\temp\temp1

***set income bracket based on equal quintiles of median HH income

pctile incMquint = medhhinc [aw=days], nq(5)
list incMquint in 1/4 


g incMq=1 if medhhinc<incMquint[1]
replace incMq=2 if medhhinc>=incMquint[1] & medhhinc<incMquint[2]
replace incMq=3 if medhhinc>=incMquint[2] & medhhinc<incMquint[3]
replace incMq=4 if medhhinc>=incMquint[3] & medhhinc<incMquint[4]
replace incMq=5 if medhhinc>=incMquint[4]

drop incMquint

sort incMq
collapse (sum) days use*, by(incMq)
drop used
g used=use/days
g mrgvar=1
sort mrgvar
merge mrgvar using c:\temp\temp2

g bill5=rate51A*use1+rate52A*use2+rate53A*use3+rate54A*use4+rate55A*use5
g bill2=rate21A*use1+rate22A*(use2+use3+use4+use5)
g bill1=rate11A*(use1+use2+use3+use4+use5)

g annbill5=365*(bill5/days)
g annbill2=365*(bill2/days)
g annbill1=365*(bill1/days)

egen totrev5=sum(bill5)
egen totrev2=sum(bill2)
egen totrev1=sum(bill1)

summ totrev* if mrgvar==1

g revshr5=bill5/totrev5
g revshr2=bill2/totrev2
g revshr1=bill1/totrev1

g avgP5=bill5/use
g avgP2=bill2/use
g avgP1=bill1/use

sort incMq

list incMq annbill*

list incMq revshr*

list incMq avgP*

egen totdays=sum(days)
g daysshr=days/totdays
list incMq used daysshr


exit
