******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #9 MEANUSERASS.DO

clear
capture log close
set more off
set mem 1200m
log using "meanuseRASS.slf", replace text

scalar popshr1=0.179
scalar popshr2=0.221
scalar popshr3=0.189
scalar popshr4=0.237
scalar popshr5=0.174


u rerank5
drop if region==.
drop if incW==.

sort w incW 
collapse (sum) use days, by(w incW)

summ use days if w==0

summ days if incW==1
scalar days_1=r(mean)
summ days if incW==2
scalar days_2=r(mean)
summ days if incW==3 
scalar days_3=r(mean)
summ days if incW==4
scalar days_4=r(mean)
summ days if incW==5
scalar days_5=r(mean)


g wused=use/days

local wgt=970
while `wgt'<=1100{

quiet summ wused if incW==1 &  w+0.0001>(`wgt'-1000)/100 & w-0.0001<(`wgt'-1000)/100
quiet scalar used_1_`wgt'=r(mean)
quiet summ wused if incW==2 &  w+0.0001>(`wgt'-1000)/100 & w-0.0001<(`wgt'-1000)/100
quiet scalar used_2_`wgt'=r(mean)
quiet summ wused if incW==3 &  w+0.0001>(`wgt'-1000)/100 & w-0.0001<(`wgt'-1000)/100
quiet scalar used_3_`wgt'=r(mean)
quiet summ wused if incW==4 &  w+0.0001>(`wgt'-1000)/100 & w-0.0001<(`wgt'-1000)/100
quiet scalar used_4_`wgt'=r(mean)
quiet summ wused if incW==5 &  w+0.0001>(`wgt'-1000)/100 & w-0.0001<(`wgt'-1000)/100
quiet scalar used_5_`wgt'=r(mean)

local wgt=`wgt'+1

}


save c:\temp\temp1, replace

clear
insheet using c:\dropbox\billtiers\RASS\survdata.csv

*** drop if utility not SCE
drop if eutil~=4

*** drop master metered
drop if substr(sfcode,1,3)=="41-"
drop if substr(sfcode,1,3)=="42-"
drop if substr(sfcode,1,3)=="43-"
drop if substr(sfcode,1,3)=="44-"

*** convert income categories to my brackets
g incR=1
replace incR=2 if income>=3
replace incR=3 if income>=7
replace incR=4 if income>=9
replace incR=5 if income>=11 & income<=12

*** create dummies of income categories
g incr1=(incR==1)
g incr2=(incR==2)
g incr3=(incR==3)
g incr4=(incR==4)
g incr5=(incR==5)

summ incr*

*** drop households that average < 1 kWh/day, drop households not occupied year round, and drop missing income data (value=97)
g used=annkwh/365 if annkwh>365 & seasocc==1 & income<=12

summ used [aw=wt] if incR==1
scalar used1=r(mean)
summ used [aw=wt] if incR==2
scalar used2=r(mean)
summ used [aw=wt] if incR==3
scalar used3=r(mean)
summ used [aw=wt] if incR==4
scalar used4=r(mean)
summ used [aw=wt] if incR==5
scalar used5=r(mean)

summ incr* used [aw=wt] if used~=. & incR~=.


replace used=(19.74/17.07)*used

reg used incr1 incr2 incr3 incr4 incr5 [aw=wt]

reg used incr1 incr2 incr3 incr4 incr5 [aw=wt], cluster(servzip)

reg used incr1 incr2 incr3 incr4 incr5 [aw=wt], noconstant 

test incr1=incr2
test incr2=incr3
test incr3=incr4
test incr4=incr5

matrix eb=e(b)

scalar usefit1=eb[1,1]

scalar usefit2=eb[1,2]

scalar usefit3=eb[1,3]

scalar usefit4=eb[1,4]

scalar usefit5=eb[1,5]

scalar list usefit1 usefit2 usefit3 usefit4 usefit5

save c:\temp\temp1, replace

local wgt=970
while `wgt'<=1100{

display `wgt'

scalar diststat=popshr1*(usefit1-used_1_`wgt')^2+popshr2*(usefit2-used_2_`wgt')^2+popshr3*(usefit3-used_3_`wgt')^2+popshr4*(usefit4-used_4_`wgt')^2+popshr5*(usefit5-used_5_`wgt')^2

scalar list diststat

display "w = "`wgt'


local wgt=`wgt'+1

}



local bsloop=1
while `bsloop'<=1000{

display "loop number = " `bsloop'

u c:\temp\temp1
bsample

reg used incr1 incr2 incr3 incr4 incr5 [aw=wt], noconstant robust

matrix eb=e(b)

scalar usefit1=eb[1,1]

scalar usefit2=eb[1,2]

scalar usefit3=eb[1,3]

scalar usefit4=eb[1,4]

scalar usefit5=eb[1,5]

scalar list usefit1 usefit2 usefit3 usefit4 usefit5


local wgt=970
while `wgt'<=1100{

display `wgt'


scalar diststat=popshr1*(usefit1-used_1_`wgt')^2+popshr2*(usefit2-used_2_`wgt')^2+popshr3*(usefit3-used_3_`wgt')^2+popshr4*(usefit4-used_4_`wgt')^2+popshr5*(usefit5-used_5_`wgt')^2

scalar list diststat

display "w = "`wgt'


local wgt=`wgt'+1

}

local bsloop=`bsloop'+1

save c:\temp\temp2, replace
}


***********



exit
